# HTC_Tree
Hierarchical Text Classification (or HTC) represents classification of text along a hierarchy, with subsequent classifications selectively applied based on previous classifications.
This repo contains a structure that represents the hierarchy of such classifications.

This is a tree with each node representing a single classification and subsequent branches representing further classifications based on the outputs of the current node.

![Diagram of an example HTC_Tree](docs/Diagrams/HTC_Tree_Example_Diagram.png)
<br>This diagram is an example of HTC_Tree structure that would predict Ford and Porsche car models and the color of the car (and for Porsches, the number of doors).
<br>This design would assume that, for whatever reason, Porsche models are 'easier' to predict if its first subdivided into the number of doors.

## Building a Tree
To build an HTC_Tree structure we use Design Files

### Design Files
Design Files are Json files that dictate the structure and ensembles withing an HTC_Tree.
<br>You use a Json in the below format to describe the structure of the tree, dictate the relevant columns, and provide an emsemble for each node.
<br><br>On structure creation, each ensemble is assigned a random ID (unless one is provided in the Design File) and uses this to (if save_ensembles is True) save a copy of the ensemble at the given path.
<br>When a Design File is generated by calling gernate_design(), the resulting file contains the Ensembles' IDs as well as the path to the already saved Ensembles.
Meaning, when it saved the Ensembles they will be saved in the same place.

Sample Design File:
```JSON
{
    "root": {
        "ensemble path": "<path to pickled Ensemble()>",
        "input column": "<input column>",
        "prediction title": "<prediction title>",
        "branches": {
            "*": [ 
                {
                    "ensemble path": "<path to pickled Ensemble()>",
                    "input column": "<input column>",
                    "prediction title": "<prediction title>",
                    "branches": {}
                }
            ],
            "<a prediction label>": [
                {
                    "ensemble path": "<path to pickled Ensemble()>",
                    "input column": "<input column>",
                    "prediction title": "<prediction title>",
                    "branches": {}
                }
            ]
        }
    },
    "parameters": {
        "verbose": true,
        "save_ensembles": true
    }    
}

```

## Training a Tree
![Diagram of training HTC_Tree](docs/Diagrams/HTC_Tree_Data_Flow_Diagram.png)



## Visualizing a Tree

